package nl.kallestruik.darena

import nl.kallestruik.darena.managers.ConfigManager
import nl.kallestruik.darena.managers.PointsManager
import nl.kallestruik.darena.managers.TeamManager
import org.bukkit.plugin.java.JavaPlugin
import java.io.File

class DArena : JavaPlugin() {
    private lateinit var configManager: ConfigManager
    private lateinit var pointsManager: PointsManager
    private lateinit var teamManager: TeamManager

    // TODO:
    // Thinking:
    // - Datastructures for arenas
    // - Datastructures for teams (Everyone is always in a team even when solo)
    // - How will points work for teams/individuals
    //      - Teams are always the same during one event
    //      - Teams on the leaderboard
    //      - Rotate teams each new game as an option
    // Programing:
    // - Loading arenas from config files
    // - Commands to interact with the plugin
    // - Custom world creation for arenas
    // - Basic arena mechanics
    // - Points system
    // - Advanced arena mechanics (Special items like fireballs)

    override fun onEnable() {
        configManager = ConfigManager(File(dataFolder, "config.yml"))
        configManager.load()

        teamManager = TeamManager(File(dataFolder, "teams.yml"))
        teamManager.load()
        pointsManager = PointsManager(teamManager, File(dataFolder, "points.yml"))
    }

    override fun onDisable() {
    }
}
