package nl.kallestruik.darena.arenas

import nl.kallestruik.darena.arenas.world.ArenaWorld
import nl.kallestruik.darena.util.ArenaUtil
import org.bukkit.potion.PotionEffect
import org.bukkit.potion.PotionEffectType

class Arena(
    private val config: ArenaConfig,
    private val world: ArenaWorld,
    private val arenaUtil: ArenaUtil,
) {
    private lateinit var session: ArenaSession
    // Simple stuff done: 0.001474s
    // createArena start: 0.0001026s
    // Loaded schematic: 0.000162s
    // Created new world: 3.122034s
    // Loaded world: 0.0075989s
    // Placed arena: 2.3205267s
    // Fixed light: 4.2093585s
    // createArena done: 0.0002953
    // Countdown done: 5.0126158
    // Fully done: 0.0982557

    fun start() {
        // Create a new session
        session = ArenaSession()
        // Add all participants and spectators
        session.participants.addAll(arenaUtil.getPossibleParticipants());
        session.spectators.addAll(arenaUtil.getPossibleSpectators());
        // Reset the world
        world.reset()
        // Place all spectators in the arena
        session.spectators.forEach {
            config.spectatorSpawn.spawn(world, it)
        }

        // Randomize spawns
        session.spawns.addAll(config.spawns)
        session.spawns.shuffle()

        // Spawn all the players
        session.participants.forEachIndexed { index, player ->
            // TODO: Freeze players in place (for in arena countdown) (if countdown is 0 dont freeze them)
            session.spawns[index % session.spawns.size].spawn(world, player)
        }
        // TODO:
    }

    fun reset() {
        world.reset()
    }
}
