package nl.kallestruik.darena.types.arena

import org.bukkit.configuration.ConfigurationSection
import javax.naming.ConfigurationException

data class ArenaCheckpoint(
    val label: String,
    val lower: ArenaLocation,
    val upper: ArenaLocation,
    val spawn: String,
) {
    companion object {
        fun loadList(section: ConfigurationSection): List<ArenaCheckpoint> {
            val list = mutableListOf<ArenaCheckpoint>()
            for (key in section.getKeys(false)) {
                list.add(load(section.getConfigurationSection(key)!!))
            }

            return list
        }

        fun load(section: ConfigurationSection): ArenaCheckpoint {
            return ArenaCheckpoint(
                section.name,
                ArenaLocation.load(section.getConfigurationSection("lower")!!),
                ArenaLocation.load(section.getConfigurationSection("upper")!!),
                section.getString("spawn") ?: throw ConfigurationException("Could not find required field spawn in '${section.currentPath}'")
            )
        }
    }
}
