package nl.kallestruik.darena.types.arena

import org.bukkit.configuration.ConfigurationSection
import org.bukkit.configuration.InvalidConfigurationException

data class ArenaEnchantment(
    val name: String,
    val level: Int,
) {
    companion object {
        fun loadList(section: ConfigurationSection): List<ArenaEnchantment> {
            val list = mutableListOf<ArenaEnchantment>()
            for (key in section.getKeys(false)) {
                list.add(load(section.getConfigurationSection(key)!!))
            }

            return list
        }

        fun load(section: ConfigurationSection): ArenaEnchantment {
            return ArenaEnchantment(
                section.getString("name") ?: throw InvalidConfigurationException("Could not find required field name in section '${section.currentPath}'"),
                section.getInt("level", 1)
            )
        }
    }
}
