package nl.kallestruik.darena.types.arena

import nl.kallestruik.darena.util.ConfigHelper
import org.bukkit.Material
import org.bukkit.configuration.ConfigurationSection

data class ArenaItem(
    val material: Material = Material.AIR,
    val amount: Int = 1,
    val enchantments: List<ArenaEnchantment> = listOf(),
    val unbreakable: Boolean = false,
) {
    companion object {
        fun loadList(section: ConfigurationSection): List<ArenaItem> {
            val list = mutableListOf<ArenaItem>()
            for (key in section.getKeys(false)) {
                list.add(load(section.getConfigurationSection(key)!!))
            }

            return list
        }

        fun load(section: ConfigurationSection): ArenaItem {
            val enchantments = section.getConfigurationSection("enchantments")?.let {
                ArenaEnchantment.loadList(it)
            } ?: listOf()

            return ArenaItem(
                ConfigHelper.matchMaterial(section.getString("material")!!),
                section.getInt("amount", 1),
                enchantments,
                section.getBoolean("unbreakable", false)
            )
        }
    }
}
