package nl.kallestruik.darena.types.arena

import org.bukkit.configuration.ConfigurationSection

data class ArenaLoadout(
    val name: String,
    val hotbar: List<ArenaItem>,
    val armor: List<ArenaItem>,
    val offhand: ArenaItem,
) {
    companion object {
        fun loadList(section: ConfigurationSection): List<ArenaLoadout> {
            val list = mutableListOf<ArenaLoadout>()
            for (key in section.getKeys(false)) {
                list.add(load(section.getConfigurationSection(key)!!))
            }

            return list
        }

        fun load(section: ConfigurationSection): ArenaLoadout {
            val hotbar = section.getConfigurationSection("hotbar")?.let {
                ArenaItem.loadList(it)
            }?: listOf()

            val armor = section.getConfigurationSection("armor")?.let {
                ArenaItem.loadList(it)
            }?: listOf()

            val offhand = section.getConfigurationSection("offhand")?.let {
                ArenaItem.load(it)
            }?: ArenaItem()

            return ArenaLoadout(
                section.name,
                hotbar,
                armor,
                offhand,
            )
        }
    }
}