package nl.kallestruik.darena.types.arena

import nl.kallestruik.darena.arenas.world.ArenaWorld
import org.bukkit.Location
import org.bukkit.configuration.ConfigurationSection
import org.bukkit.entity.Player

data class ArenaSpawn(
    val label: String,
    val x: Double,
    val y: Double,
    val z: Double,
    val yaw: Float,
    val pitch: Float,
    val loadout: String
) {
    fun spawn(world: ArenaWorld, player: Player) {
        player.teleport(Location(world.world, x, y, z, yaw, pitch))
    }

    companion object {
        fun loadList(section: ConfigurationSection): List<ArenaSpawn> {
            val list = mutableListOf<ArenaSpawn>()

            for (key in section.getKeys(false)) {
                list.add(load(section.getConfigurationSection(key)!!))
            }

            return list
        }

        fun load(section: ConfigurationSection): ArenaSpawn {
            return ArenaSpawn(
                section.name,
                section.getDouble("x"),
                section.getDouble("y"),
                section.getDouble("z"),
                section.getDouble("yaw").toFloat(),
                section.getDouble("pitch").toFloat(),
                section.getString("loadout")!!
            )
        }
    }
}